using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Runtime.InteropServices;
using System.IO;
using System.Threading;

namespace WebCam
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		[DllImport("user32.dll")] private static extern 
            bool SetForegroundWindow(IntPtr hWnd);
		[DllImport("user32.dll")] private static extern 
			IntPtr GetWindowThreadProcessId(IntPtr hWnd, IntPtr ProcessId);
		[DllImport("user32.dll")] private static extern 
			IntPtr GetForegroundWindow();
		
		private IMotionDetector detector;
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.Button button1;
		private WebCam_Capture.WebCamCapture WebCamCapture;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Button button3;
		private Bitmap bitmap;
		private bool funky;
		private bool motionDetect;
		private int[,] pixels;
		private int[] motionCount;
		private System.Windows.Forms.Button button4;
		private System.Windows.Forms.Button button5;
		private System.Windows.Forms.ComboBox comboBox1;
		private System.Windows.Forms.Button button6;
		private System.Windows.Forms.ComboBox comboBox2;
		private string toSend;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Button button7;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox textBox2;
		private System.Windows.Forms.TextBox textBox3;
		private System.Windows.Forms.TextBox textBox4;
		private System.Windows.Forms.TextBox textBox5;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			pixels = new int[320,240];
			motionCount = new int[5];
			for (int i = 0; i < 5; i++)
				motionCount[i] = 0;
			funky = motionDetect = false;
			InitializeComponent();
			toSend = "{x}";
			detector = new MotionDetector3Optimized();
			this.WebCamCapture = new WebCam_Capture.WebCamCapture();
			this.WebCamCapture.CaptureHeight = 240;
			this.WebCamCapture.CaptureWidth = 320;
			// TODO: Code generation for 'this.WebCamCapture.FrameNumber' failed because of Exception 'Invalid Primitive Type: System.UInt64. Only CLS compliant primitive types can be used. Consider using CodeObjectCreateExpression.'.
			this.WebCamCapture.Location = new System.Drawing.Point(17, 17);
			this.WebCamCapture.Name = "WebCamCapture";
			this.WebCamCapture.Size = new System.Drawing.Size(342, 252);
			this.WebCamCapture.TabIndex = 0;
			this.WebCamCapture.TimeToCapture_milliseconds = 1;
			this.WebCamCapture.ImageCaptured += new WebCam_Capture.WebCamCapture.WebCamEventHandler(this.WebCamCapture_ImageCaptured);
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			// set the image capture size
			this.WebCamCapture.CaptureHeight = this.pictureBox1.Height;
			this.WebCamCapture.CaptureWidth = this.pictureBox1.Width;
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.button3 = new System.Windows.Forms.Button();
			this.button4 = new System.Windows.Forms.Button();
			this.button5 = new System.Windows.Forms.Button();
			this.comboBox1 = new System.Windows.Forms.ComboBox();
			this.button6 = new System.Windows.Forms.Button();
			this.comboBox2 = new System.Windows.Forms.ComboBox();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.button7 = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.textBox2 = new System.Windows.Forms.TextBox();
			this.textBox3 = new System.Windows.Forms.TextBox();
			this.textBox4 = new System.Windows.Forms.TextBox();
			this.textBox5 = new System.Windows.Forms.TextBox();
			this.SuspendLayout();
			// 
			// pictureBox1
			// 
			this.pictureBox1.Location = new System.Drawing.Point(168, 56);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(320, 240);
			this.pictureBox1.TabIndex = 0;
			this.pictureBox1.TabStop = false;
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(488, 496);
			this.button1.Name = "button1";
			this.button1.TabIndex = 1;
			this.button1.Text = "Start";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(576, 496);
			this.button2.Name = "button2";
			this.button2.TabIndex = 2;
			this.button2.Text = "Stop";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// button3
			// 
			this.button3.Location = new System.Drawing.Point(160, 496);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(136, 23);
			this.button3.TabIndex = 3;
			this.button3.Text = "Skin Recognition Mode";
			this.button3.Click += new System.EventHandler(this.button3_Click);
			// 
			// button4
			// 
			this.button4.Location = new System.Drawing.Point(400, 496);
			this.button4.Name = "button4";
			this.button4.TabIndex = 4;
			this.button4.Text = "Size";
			this.button4.Click += new System.EventHandler(this.button4_Click);
			// 
			// button5
			// 
			this.button5.Location = new System.Drawing.Point(512, 528);
			this.button5.Name = "button5";
			this.button5.Size = new System.Drawing.Size(136, 23);
			this.button5.TabIndex = 5;
			this.button5.Text = "Generate Process List";
			this.button5.Click += new System.EventHandler(this.button5_Click);
			// 
			// comboBox1
			// 
			this.comboBox1.Location = new System.Drawing.Point(8, 528);
			this.comboBox1.Name = "comboBox1";
			this.comboBox1.Size = new System.Drawing.Size(200, 21);
			this.comboBox1.TabIndex = 6;
			this.comboBox1.SelectedIndexChanged += new System.EventHandler(this.comboBox1_SelectedIndexChanged);
			// 
			// button6
			// 
			this.button6.Location = new System.Drawing.Point(312, 496);
			this.button6.Name = "button6";
			this.button6.TabIndex = 7;
			this.button6.Text = "Send Key";
			this.button6.Click += new System.EventHandler(this.button6_Click);
			// 
			// comboBox2
			// 
			this.comboBox2.Location = new System.Drawing.Point(216, 528);
			this.comboBox2.Name = "comboBox2";
			this.comboBox2.Size = new System.Drawing.Size(208, 21);
			this.comboBox2.TabIndex = 8;
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(168, 32);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(64, 20);
			this.textBox1.TabIndex = 9;
			this.textBox1.Text = "z";
			// 
			// button7
			// 
			this.button7.Location = new System.Drawing.Point(8, 496);
			this.button7.Name = "button7";
			this.button7.Size = new System.Drawing.Size(136, 23);
			this.button7.TabIndex = 10;
			this.button7.Text = "Motion Detection Mode";
			this.button7.Click += new System.EventHandler(this.button7_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(504, 472);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(144, 23);
			this.label1.TabIndex = 11;
			// 
			// textBox2
			// 
			this.textBox2.Location = new System.Drawing.Point(232, 32);
			this.textBox2.Name = "textBox2";
			this.textBox2.Size = new System.Drawing.Size(64, 20);
			this.textBox2.TabIndex = 12;
			this.textBox2.Text = "x";
			// 
			// textBox3
			// 
			this.textBox3.Location = new System.Drawing.Point(296, 32);
			this.textBox3.Name = "textBox3";
			this.textBox3.Size = new System.Drawing.Size(64, 20);
			this.textBox3.TabIndex = 13;
			this.textBox3.Text = "c";
			// 
			// textBox4
			// 
			this.textBox4.Location = new System.Drawing.Point(360, 32);
			this.textBox4.Name = "textBox4";
			this.textBox4.Size = new System.Drawing.Size(64, 20);
			this.textBox4.TabIndex = 14;
			this.textBox4.Text = "v";
			// 
			// textBox5
			// 
			this.textBox5.Location = new System.Drawing.Point(424, 32);
			this.textBox5.Name = "textBox5";
			this.textBox5.Size = new System.Drawing.Size(64, 20);
			this.textBox5.TabIndex = 15;
			this.textBox5.Text = "b";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(656, 558);
			this.Controls.Add(this.textBox5);
			this.Controls.Add(this.textBox4);
			this.Controls.Add(this.textBox3);
			this.Controls.Add(this.textBox2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.button7);
			this.Controls.Add(this.textBox1);
			this.Controls.Add(this.comboBox2);
			this.Controls.Add(this.button6);
			this.Controls.Add(this.comboBox1);
			this.Controls.Add(this.button5);
			this.Controls.Add(this.button4);
			this.Controls.Add(this.button3);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.pictureBox1);
			this.Name = "Form1";
			this.Text = "WebCam Test";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			this.WebCamCapture.Start(0);
		}

		private void WebCamCapture_ImageCaptured(object source, WebCam_Capture.WebcamEventArgs e)
		{
			// set the picturebox picture
			bitmap = new Bitmap(e.WebCamImage);
			if (!funky && !motionDetect)
			{
				this.pictureBox1.Image = e.WebCamImage;
			}

			if (funky)
			{
				int widthB = bitmap.Width;
				int heightB = bitmap.Height;
				int i, j;
				for (i = 0; i< widthB; i++) 
				{
					for (j=0; j<heightB; j++)
					{
						Color pixelColor = bitmap.GetPixel(i, j);
						if (isSkinColour(pixelColor))
						{
							Color newColor = Color.FromArgb(0,0,255);
							bitmap.SetPixel(i, j, newColor);
						}
					}
				}
				pictureBox1.Image = bitmap;
			}

			if (motionDetect)
			{
				detector.ProcessFrame(ref bitmap);
				detector.ProcessFrame(ref bitmap);
				pixels = detector.getPixels();
				for (int i = 0; i < 320; i++)
				{
					for (int j = 0; j < 240;j++)
						if (pixels[i,j] == 255)
							bitmap.SetPixel(i,j,Color.Red);
				}
				pictureBox1.Image = bitmap;
				
				if(detectMotion(0))
					sendKey(textBox1.Text);
				if(detectMotion(1))
					sendKey(textBox2.Text);
				if(detectMotion(2))
					sendKey(textBox3.Text);
				if(detectMotion(3))
					sendKey(textBox4.Text);
				if(detectMotion(4))
					sendKey(textBox5.Text);

				label1.Text = detector.MotionLevel.ToString();
			}
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			this.WebCamCapture.Stop();
		}

		private void button3_Click(object sender, System.EventArgs e)
		{
			if (funky)
				funky = false;
			else
				funky = true;
			
		}

		private void button4_Click(object sender, System.EventArgs e)
		{
			if (this.WebCamCapture.CaptureHeight == 480)
			{
				this.WebCamCapture.CaptureHeight = 240;
				this.WebCamCapture.CaptureWidth = 320;
			}
			else
			{
				this.WebCamCapture.CaptureHeight = 480;
				this.WebCamCapture.CaptureWidth = 640;
			}
		}

		private bool isSkinColour(Color skin)
		{
			if (skin.R > 95 && skin.G > 40 && skin.B > 20)
			{
				if (max(skin.R,skin.G,skin.B) - min(skin.R,skin.G,skin.B) > 15)
				{
					
					if ( Math.Abs(skin.R-skin.G) > 15)
					{
						if (skin.R > skin.G && skin.R > skin.B)
							return true;
					}
				}
			}

			if (skin.R > 220 && skin.G > 210 && skin.B > 170)
			{
				if (Math.Abs(skin.R - skin.G) <= 15)
				{
					if (skin.R > skin.B && skin.G > skin.B)
						return true;
				}
			}

			return false;
		}

		private int max(int a, int b, int c)
		{
			if (a > b)
			{
				if (a > c)
					return a;
				else
					return c;
			}
			else
			{
				if (b > c)
					return b;
				else
					return c;
			}
		}

		private int min(int a, int b, int c)
		{
			if (a < b)
			{
				if (a < c)
					return a;
				else
					return c;
			}
			else
			{
				if (b < c)
					return b;
				else
					return c;
			}
		}

		private void button5_Click(object sender, System.EventArgs e)
		{
			comboBox1.Items.Clear();
			comboBox2.Items.Clear();
			Windows wndList = new Windows(false,true);
			foreach (Window wnd in wndList) {comboBox1.Items.Add(wnd);}
			wndList = new Windows(false,true);
			foreach (Window wnd in wndList) {comboBox2.Items.Add(wnd.hWnd.ToString());}
		}

		private void button6_Click(object sender, System.EventArgs e)
		{
			sendKey(textBox1.Text);
		}

		private void comboBox1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			comboBox2.SelectedIndex = comboBox1.SelectedIndex;
		}

		private void button7_Click(object sender, System.EventArgs e)
		{
			if (motionDetect)
				motionDetect = false;
			else
				motionDetect = true;
		}

		private void sendKey(string key)
		{
			toSend = "{" + key + "}";
			System.IntPtr current = GetForegroundWindow();
			System.IntPtr process = new IntPtr(Convert.ToInt32(comboBox2.SelectedItem.ToString()));
			SetForegroundWindow(process);
			Thread.Sleep(100);
			if(toSend != "{}")
				SendKeys.SendWait(toSend);
			Thread.Sleep(200);
			SetForegroundWindow(current);
		}

		private bool detectMotion(int pos)
		{
			int count = 0;

			for (int i = 0; i < 64; i++)
			{
				for (int j = 0; j < 64; j++)
				{
					if (pixels[i+64*pos,j] == 255)
						count++;
				}
			}

			if (count > 64)
			{
				if (motionCount[pos] < 4096)
					motionCount[pos]+=64;
				else
					motionCount[pos] = 0;
			}
				
			int row = 64;
			for (int i = 0; i < motionCount[pos]; i++)
			{
				bitmap.SetPixel(i%64+pos*64,row,Color.Blue);
				if (i%64 == 0 && i != 0)
					row--;
			}

			if (motionCount[pos] == 4096)
			{
				motionCount[pos] = 0;
				return true;
			}
			return false;
		}
	}
}
